# caosdb-cppinttest

Integration tests for caosdb-cpplib and the caosdb-server

# Dependencies

* clang-tidy
* clang-format
* include-what-you-use
* cmake
* conan

# Run tests

## Prerequisites

Create a local conan package from the caosdb-cpplib repository

## Build & Execution

```
make test-release
```

or manually via

1. `conan install . -s build_type=<Debug/Release> --build=missing`
2. `cmake --preset conan-<debug/release>`
3. `cd build <Debug/Release>`
4. `cmake --build .`
5. Provide client configuration at `~/.caosdb-client.json` or via any other method described in the docs.
6. There are tests which need access to the server's certificate file. Define
   path to the pem file in the `CAOSDB_SERVER_CERT` environment variable.
7. Run with `ctest` in the build directory.

### Troubleshooting ###

- If you don't have `clang-tidy` installed, you can run the first `cmake` command with
  `LINTING=OFF`: `cmake -D LINTING=OFF -B . ..`

## Formatting, style, linting ##

`make format`
